#!/usr/bin/env python


from subprocess import call
from functools import partial
from multiprocessing.dummy import Pool
import numpy as np
import random
import time
import sys


# define the commands to be run in parallel
    
nr_particles = 1
nr_1MEV_elec_required = 20
list_primary_energy = [0.075]  # MeV
list_physicsList= ['O1','O4','SS']
#list_physicsList= ['O1']
#list_physics= ['LIV','O4','O1','PEN']
list_Efields = [8.e5] # V/m
list_direction=["+1"]
#max_step_list = [0.00001,0.00003,0.0001,0.0003,0.001,0.003,0.01,0.03,0.1,0.3,1,3,10,30.,100., 300.,1000.] # mm
#max_step_list = [0.001,0.003,0.01,0.03,0.1,0.3,1,3,10,30.,100., 300.,1000.] # mm
max_step_list = [0.0001,0.0003] # mm
#max_step_list = [300.] # mm
#max_step_list = [1000.] # mm
max_step_list = max_step_list[::-1]

nb_runs = 1000

commands=[]

excecutable = './BaseAV'
rand_seed = 10000

for direction in list_direction:
    for primary_energy in list_primary_energy:
        for field in list_Efields:
            for max_step in max_step_list:
                for physicsList in list_physicsList:
                    for _ in range(nb_runs):
                        commands.append(excecutable+' '+str(physicsList)+' '+str(nr_particles)+' '+str(field)+' '+str(primary_energy)+' '+str(nr_1MEV_elec_required)+' '+str(rand_seed)+' '+str(direction)+' '+str(max_step))
                        rand_seed=rand_seed+1


command_number=len(commands)

print('Number of commands required '+ str(command_number))

pool = Pool(4) # Nomber of threads
for i, returncode in enumerate(pool.imap(partial(call, shell=True), commands)):
    if returncode != 0:
       print("%d command failed: %d" % (i, returncode))
